--[[
	@brief: Client main function.
	@param：main.lua
	@date：Created by Dongyang Cai on 26/9/2014
]]

require("Cocos2d")
require("Cocos2dConstants")

require("systool.systool")
require("core.RenderUnit")
require("update.GameLogin")
require("update.UpdateController")
require("config.config_php")
require("net.NetUnit")

--记录Update的当前时间和间隔时间
Status = {}

--记录当前系统信息
SystemInfo = {}

HandleRenderUnit = HandleRenderUnit or nil

--[[
	@brief: Error handle function.
]]
function __G__TRACKBACK__(msg)
	log("LUA ERROR: "..msg)
	log(debug.traceback())
end

--[[
	@brief: Game entrance.
]]
function Start()
	--设置垃圾回收频率
	collectgarbage("setpause", 120)
	collectgarbage("setstepmul", 5000)

	SystemInfo.platform = cc.Application:getInstance():getTargetPlatform()
	SystemInfo.deviceId = cc.Application:getInstance():getDeviceID()
	SystemInfo.mac = cc.Application:getInstance():getMacAddress()

	--设置FPS
	cc.Director:getInstance():setAnimationInterval(1.0 / 1000)

    --初始化主渲染器
	HandleRenderUnit = RenderUnit.New("MainRenderUnit")
	HandleRenderUnit:InitAsMainStage()

	--显示登陆界面
	updateController = UpdateController.New()
	UpdateModel:getInstance():Fire(UpdateModel.SHOW_UPDATE_VIEW)
end

function Update(now_time, elapse_time)
	Status.NowTime = now_time
	Status.ElapseTime = elapse_time
	if MyGameDeactive then return end
	Runner:getInstance():Update(now_time, elapse_time)
end

function Stop()
	Update = function() end
	if GameLogin then
		GameLogin.Stop()
	end
end

function BeforeActive()
	MyGameDeactive = nil
	if GameLogin then
		GameLogin.BeforeActive()
	end
end

function Deactive()
	MyGameDeactive = os.clock()
	if GameLogin then
		GameLogin.Deactive()
	end
end

function OnNetworkChange(network_type)
	if GameLogin then
		GameLogin.OnNetworkChange(network_type)
	end
end

function OnNetAsyncConnected(is_suc, handle, netid)
	GameLogin.OnNetAsyncConnected(is_suc, handle, netid)
end

function OnNetRecv(msg_type, net_id)
	GameLogin.OnNetRecv(msg_type, net_id)
end

function OnNetDisconnect(net_id)
	GameLogin.OnNetDisconnect(net_id)
end

function ShowError( type )
	SAlert.New(Config.Update.LOGIN_ALERT[1], function() cc.Director:getInstance():endToLua() end, Config.Update.CONST_DES[4])
end

--Bind error function handler
-- xpcall(Start, __G__TRACKBACK__)