--[[
	@brief: Client login network unit.
	@param：net/NetUnit.lua
	@date：Created by Dongyang Cai on 26/9/2014
]]

require("net.ClientConfig")

NetUnit = NetUnit or BaseClass()

function NetUnit:__init()
	NetUnit._instance = self
end

function NetUnit:__delete()
	NetUnit._instance = nil
end

function NetUnit:getInstance()
	if NetUnit._instance == nil then
		NetUnit.New()
	end
	return NetUnit._instance
end

--[[
	@brief: 初始化客户端与服务器的连接
]]
function NetUnit:initNet()
    local variables = {}
    variables.gid = "fantasy"
    variables.platform = tostring(Config.PHP.PlatID)
    variables.chg = tostring(Config.PHP.ChannelID)
    variables.phone_id = tostring(cc.Application:getInstance():getDeviceID())
    variables.mac = tostring(cc.Application:getInstance():getMacAddress())
    if SystemInfo.platform == cc.PLATFORM_OS_ANDROID then
        variables.os = "android"
    elseif SystemInfo.platform == cc.PLATFORM_OS_WINDOWS then
        variables.os = "windows"
    elseif SystemInfo.platform == cc.PLATFORM_OS_MAC then
        variables.os = "mac"
    elseif SystemInfo.platform == cc.PLATFORM_OS_IPHONE or SystemInfo.platform == cc.PLATFORM_OS_IPAD then
        variables.os = "ios"
    end
    local function request_call_back(result, php_str)
    	if result and tostring(php_str) == "1" then
    		print("set channelID |" .. Config.PHP.ChannelID .. "|" .. cc.Application:getInstance():getDeviceID())
    	end
    end
    print("send channelID |"..Config.PHP.ChannelID.."|"..cc.Application:getInstance():getDeviceID())
    cc.ResService:getInstance():postHttpTask(Config.PHP.RestartTimes, variables,request_call_back)
end