function PrintTable( tbl , level, print_lv ,is_log)
	-- print(debug.traceback())
	level = level or 1
	print_lv = print_lv or -1 --输出table的层数，没有则为-1，层层递归下去-1不会因为=0为退出递归

    if level > 5 and (print_lv < 0) then--以防死循环输出表
        print("Nhập số tầng quá nhiều nên đã bị hủy~")
        return
    end

	if print_lv == 0 then
		return
	end

	local print_func = function( str )
		if is_log then
			print(str)
		else
			print(str)
		end
	end

	if tbl == nil then
		print("PrintTable function parameter is nil")
		return
	end

	local indent_str = ""
	for i = 1, level do
		indent_str = indent_str.."	"
	end

	print_func(indent_str .. "{")

	for k,v in pairs(tbl) do

		local item_str = string.format("%s%s = %s", indent_str .. "	",tostring(k), tostring(v))
		print_func(item_str)
		if type(v) == "table" then
			PrintTable(v, level + 1, print_lv - 1 , is_log)
		end
	end
	print_func(indent_str .. "}")
end

-- 外部库 登记
local package_list = package_list or {
    bit = true,
    lfs = true,
    cjson = true,
    pb = true,
    socket = true,
}

-- 全局性质类/或禁止重新加载的文件记录
local ignored_file_list = ignored_file_list or {
	["systool.systool"] = true,
	["utils.util"] = true,
	["utils.luaj"] = true,
	["utils.luaoc"] = true,
	["game.loadbg.LoadController"] = true,
	["core.DrawObject"] = true,
	["core.TerrainHelper"] = true,

	["game.cheats.CheatsClient"] = true,

	["game.common.BaseLayout"] = true,
	["game.common.BaseView"] = true,
	["game.common.WindowMgr"] = true,

	["component.ComponentManager"] = true,
	["component.UIControl"] = true,
	["config.config"] = true,

	["game.common.GameDefine"] = true,
	["game.common.GlobalEvents"] = true,
	["game.common.GameResPathTool"] = true,
	["game.common.CDManager"] = true,
	["game.common.BaseController"] = true,
	["game.common.BaseVo"] = true,
	["game.common.CacheManager"] = true,

	["utils.TimeUtil"] = true,
	["utils.Message"] = true,
	["utils.MessageForAnimation"] = true,
	["utils.util"] = true,
	["utils.utilsClasses"] = true,

	["operation.OperateManager"] = true,

	["net.GameNet"] = true,

	["game.sharedata.GameVoManager"] = true,

	["game.role.RoleManager"] = true,

	["game.goods.GoodsManager"] = true,

	["game.tips.TipsManager"] = true,
	["game.tips.FlyTips"] = true,

	["game.guide.GuideControll"] = true,

	["game.audio.AudioManager"] = true,

	["game.scene.sceneboard.FlyDisplayer"] = true,

	["game.loadbg.LoadController"] = true,

	["game.gameloop.GameLoop"] = true,

	["game.scene.Scene"] = true,
}

--已重新加载的文件记录
local loaded_file_list = loaded_file_list or {}

--视图排版控制
function leading_tag( indent )
    -- body
    if indent < 1 then
        return ''
    else
        return string.rep( '    |',  indent - 1  ) .. '    '
    end
end

--关键递归重新加载函数
--filename 文件名
--indent   递归深度, 用于控制排版显示
function recursive_reload( filename, indent )
	if ignored_file_list[ filename] then
		print( leading_tag(indent) .. filename .. "... IGNORED" )
		return
	end

    -- body
    if package_list[ filename] then
        --对于 外部库, 只进行重新加载, 不做递归子文件
        --卸载旧文件
        package.loaded[ filename] = nil

        --装载信文件
        require( filename )

        --标记"已被重新加载"
        loaded_file_list[ filename] = true

        --print( leading_tag(indent) .. filename .. "... done" )
        return true
    end

    --普通文件
    --进行 "已被重新加载" 检测
    if loaded_file_list[ filename] then
        --print( leading_tag(indent) .. filename .. "...already been reloaded IGNORED" )
        return true
    end

    local filepath = string.gsub(filename, "%.", "/")
    local fullPath = cc.FileUtils:getInstance():fullPathForFilename("scripts/"..filepath..'.lua');
    --print(fullPath)
    --读取当前文件内容, 以进行子文件递归重新加载
    local file, err = io.open( fullPath )
    if file == nil then
        print( string.format( "failed to reaload file(%s), with error:%s", fullPath, err or "unknown" ) )
        return false
    end

    print( leading_tag(indent) .. filename)

    -- 缓存文件内容，及时关闭文件，否则文件不可写入
    local data = {}
    local comment = false
    for line in file:lines() do
        -- line = string.trim(line)
        line = string.gsub(line, " ", "")
        if string.find(line, '%-%-%[%[%-%-') ~= nil then
            comment = true
        end

        if comment and (string.find(line, '%]%]') ~= nil or string.find(line, '%-%-%]%]%-%-') ~= nil) then
            comment = false
        end

        -- 被注释掉的，和持有特殊标志的require文件不重新加载
        local linecomment = (line[1] == '-' and line[2] == '-')
        if not comment and not linecomment and string.find(line, '%-%- Ignore Reload') == nil  then
            table.insert(data, line);
        end
    end

    io.close(file)

    local function getFileName(line)
        local begIndex = string.find(line, "'");
        local endIndex = string.find(line, "'", (begIndex or 1) + 1)
        if begIndex == nil or endIndex == nil then
            begIndex = string.find(line, '"');
            endIndex = string.find(line, '"', (begIndex or 1) + 1)
        end

        if begIndex == nil or endIndex == nil then
            return nil;
        end

        return string.sub(line, begIndex + 1, endIndex - 1)
    end

    -- 先解析文件，加载里面的子文件
    for _,line in ipairs(data) do
        -- 去除空白符
        --line = string.gsub( line, '%s', '' )
        local subFileName = nil
        if string.find(line, 'require') ~= nil then
            subFileName = getFileName(line);
        elseif string.find(line, 'import') ~= nil then
            -- TODO 兼容import 通过fullPath进行解析
            subFileName = nil
        end

        if subFileName then
            -- print('file: %s     subFile: %s', line, subFileName)
            --进行递归
            local success = recursive_reload( subFileName, indent + 1 )
            if not success then
                print( string.format( "failed to reload sub file of (%s)", filename ) )
                return false
            end

        end
    end

    -- -- "后序" 处理当前文件...
    -- if ignored_file_list[ filename] then
    --     --忽略 "禁止被重新加载"的文件
    --     print( leading_tag(indent) .. filename .. "... IGNORED" )
    --     return true
    -- else

        --卸载旧文件
        package.loaded[ filename] = nil

        --装载新文件
        require(filename)

        --设置"已被重新加载" 标记
        loaded_file_list[ filename] = true
        --print( leading_tag(indent) .. filename .. "... done" )
        return true
    -- end
end

--主入口函数
function reload_script_files(filename)
    print( "[reload_script_files...]")

    loaded_file_list = {}

    --本项目是以 main.lua 为主文件
    recursive_reload( filename, 0 )
    print( "[reload_script_files...done]")

    return "reload ok"
end