--[[
    @brief: Game udpate view.
    @param：update/GameLogin.lua
    @date：Created by Dongyang Cai on 4/11/2014
]]

GameLogin = GameLogin or {}

function GameLogin.Start()
	print("--------- >> GAME LOGIN")

	--初始化SDK
	GameLogin.initSdk()

	--全局事件
	GlobalEventSystem = GlobalEventSystem or nil
	--全局时间函数
	GlobalTimerQuest = GlobalTimerQuest or nil
	--场景地形
	HandleTerrainHandler = HandleTerrainHandler or nil

	GlobalEventSystem = EventSystem.New()
	Runner:getInstance():AddRunObj(GlobalEventSystem, 3)

	GlobalTimerQuest = TimerQuest:new()
	Runner:getInstance():AddRunObj(GlobalTimerQuest, 3)

	HandleTerrainHandler = TerrainHelper.New(HandleRenderUnit)

	--操作时间的函数
	TimeUtil.New()
	--状态机
	OperateManager.New()
	--网络连接
    GameNet.New()
    --vo管理器
	GameVoManager.New()
	--模块Controller
 	modules_controller = ModulesController.New()
	--缓存管理
	-- CacheManager.New()
end

function GameLogin.Stop()
	print("enter global stop function!")

	sdkUtils:exit()

	HandleTerrainHandler:DeleteMe()
	HandleTerrainHandler = nil

	GameVoManager.Instance:DeleteMe()
	GameVoManager.Instance = nil

	ModulesController.Instance:DeleteMe()
	ModulesController.Instance = nil

	OperateManager.Instance:DeleteMe()
	OperateManager.Instance = nil

	GameNet:getInstance():DeleteMe()

	TimeUtil.Instance:DeleteMe()
	TimeUtil.Instance = nil

	GlobalTimerQuest = nil

	GlobalEventSystem:DeleteMe()
	GlobalEventSystem = nil

	Runner:getInstance():DeleteMe()
end

function GameLogin.BeforeActive()
	--激活
	-- print("enter global beforactive function!")
	-- GameNet:getInstance():Reconnect()
end

--[[
	@brief: 游戏挂起状态获取状态变量
]]
function GameLogin.Deactive()
	--推图副本体力恢复满100
	cc.UserDefault:getInstance():setIntegerForKey("Inception_pow", InceptionModel:getInstance():getRecoverTime())
	--玩家探险功能恢复24次次数
	cc.UserDefault:getInstance():setIntegerForKey("Adventure_times", AdventureController.Instance:getAdventureTime())
	--淘宝免费机会1次
	cc.UserDefault:getInstance():setIntegerForKey("Taobao_times_1", TaobaoModel:getInstance():getTime(1))
	cc.UserDefault:getInstance():setIntegerForKey("Taobao_times_2", TaobaoModel:getInstance():getTime(2))
	cc.UserDefault:getInstance():setIntegerForKey("Taobao_times_3", TaobaoModel:getInstance():getTime(3))
	--经验找回沙漏满
	cc.UserDefault:getInstance():setIntegerForKey("expFind_times", expFindModel
:getInstance():getSurplusTime())

	sdkUtils:exit()

	--挂起
	-- print("enter global deactive function!")
	-- GameNet:getInstance():DisconnectGameServer()
end

--[[
	@brief: 初始化SDK环境
]]
function GameLogin.initSdk()
	local cur_platform = cc.Application:getInstance():getTargetPlatform()
	local platform = Config.PHP.PlatID
	print("========platform", platform)
	GlobalCustom = {}
	GlobalCustom.custom = ""

	if cur_platform == cc.PLATFORM_OS_WINDOWS then
		Config.PHP.PlatID = "215"
		local sdk = require("sdk.Localsdk")
		sdkUtils = Localsdk.New(platform)
		sdkUtils.plat = "android"
	elseif cur_platform == cc.PLATFORM_OS_ANDROID then
		luaj = require("utils.luaj")

		if platform == "215" then
			require("sdk.Localsdk")
			sdkUtils = Localsdk.New(platform)
		elseif platform == "mi" then
			require("sdk.MiSdk")
			sdkUtils = MiSdk.New(platform)
		elseif platform == "tencent" then
			require("sdk.TencentSdk")
			sdkUtils = TencentSdk.New(platform)
		elseif platform == "qh" then
			require("sdk.QhSdk")
			sdkUtils = QhSdk.New(platform)
		elseif platform == "uc" then
			require("sdk.UcSdk")
			sdkUtils = UcSdk.New(platform)
		elseif platform == "dl" then
			require("sdk.DlSdk")
			sdkUtils = DlSdk.New(platform)
		elseif platform == "youku" then
			require("sdk.YkSdk")
			sdkUtils = YkSdk.New(platform)
		elseif platform == "huawei" then
			require("sdk.HwSdk")
			sdkUtils = HwSdk.New(platform)
		elseif platform == "meizu" then
			require("sdk.MzSdk")
			sdkUtils = MzSdk.New(platform)
		elseif platform == "unicom" then
			require("sdk.UnicomSdk")
			sdkUtils = UnicomSdk.New(platform)
		elseif platform == "amigo" then
			require("sdk.AmSdk")
			sdkUtils = AmSdk.New(platform)
		elseif platform == "coolmart" then
			require("sdk.KupaiSdk")
			sdkUtils = KupaiSdk.New(platform)
		elseif platform == "ccplay" then
			require("sdk.CcplaySdk")
			sdkUtils = CcplaySdk.New(platform)
		elseif platform == "sy4399" then
			require("sdk.M4399Sdk")
			sdkUtils = M4399Sdk.New(platform)
		elseif platform == "wdj" then
			require("sdk.WdjSdk")
			sdkUtils = WdjSdk.New(platform)
		elseif platform == "nduoa" then
			require("sdk.NduoaSdk")
			sdkUtils = NduoaSdk.New(platform)
		elseif platform == "nmgc" then
			require("sdk.NmgcSdk")
			sdkUtils = NmgcSdk.New(platform)
		elseif platform == "sy37" then
			require("sdk.Sy37Sdk")
			sdkUtils = Sy37Sdk.New(platform)
		elseif platform == "pps" then
			require("sdk.PpsSdk")
			sdkUtils = PpsSdk.New(platform)
		elseif platform == "pptv" then
			require("sdk.PptvSdk")
			sdkUtils = PptvSdk.New(platform)
		elseif platform == "sogou" then
			require("sdk.SogouSdk")
			sdkUtils = SogouSdk.New(platform)
		elseif platform == "gfan" then
			require("sdk.GfanSdk")
			sdkUtils = GfanSdk.New(platform)
		elseif platform == "hm" then
			require("sdk.HmSdk")
			sdkUtils = HmSdk.New(platform)
		elseif platform == "bd" then
			require("sdk.BdSdk")
			sdkUtils = BdSdk.New(platform)
		elseif platform == "az" then
			require("sdk.AzSdk")
			sdkUtils = AzSdk.New(platform)
		elseif platform == "vivo" then
			require("sdk.VivoSdk")
			sdkUtils = VivoSdk.New(platform)
		elseif platform == "xyzs" then
			require("sdk.XyzsSdk")
			sdkUtils = XyzsSdk.New(platform)
		elseif platform == "shoumeng" then
			require("sdk.ShoumengSdk")
			sdkUtils = ShoumengSdk.New(platform)
		elseif platform == "game073" then
			require("sdk.ShuyouSdk")
			sdkUtils = ShuyouSdk.New(platform)
		elseif platform == "lenovo" then
			require("sdk.LenovoSdk")
			sdkUtils = LenovoSdk.New(platform)
		elseif platform == "yyh" then
			require("sdk.YyhSdk")
			sdkUtils = YyhSdk.New(platform)
		elseif platform == "guopan" then
			require("sdk.GuopanSdk")
			sdkUtils = GuopanSdk.New(platform)
		elseif platform == "htc" then
			require("sdk.HtcSdk")
			sdkUtils = HtcSdk.New(platform)
		elseif platform == "kaopu" then
			require("sdk.KaopuSdk")
			sdkUtils = KaopuSdk.New(platform)
		elseif platform == "lewan" then
			require("sdk.LewanSdk")
			sdkUtils = LewanSdk.New(platform)
		elseif platform == "telecom" then
			require("sdk.EgameSdk")
			sdkUtils = EgameSdk.New(platform)
		elseif platform == "zhaole" then
			require("sdk.ZhaoleSdk")
			sdkUtils = ZhaoleSdk.New(platform)
		elseif platform == "sguo" then
			require("sdk.SguoSdk")
			sdkUtils = SguoSdk.New(platform)
		elseif platform == "soha" then
			require("sdk.SohaSdk")
			sdkUtils = SohaSdk.New(platform)
			print("========sdk.SohaSdk")
		else
			require("sdk.AndroidSdk")
			sdkUtils = AndroidSdk.New(platform)
		end
		sdkUtils.plat = "android"
	elseif cur_platform == cc.PLATFORM_OS_IPHONE or cur_platform == cc.PLATFORM_OS_IPAD then
		if platform == "xyzsios" then
			require("sdk.XySdk")
			sdkUtils = XySdk.New(platform)
		elseif platform == "dlios" then
			require("sdk.DliOSSdk")
			sdkUtils = DliOSSdk.New(platform)
		elseif platform == "kyios" then
			require("sdk.KySdk")
			sdkUtils = KySdk.New(platform)
		elseif platform == "appstore" then
			require("sdk.AppStore")
			sdkUtils = AppStore.New(platform)
		elseif platform == "itools" then
			require("sdk.ItoolsSdk")
			sdkUtils = ItoolsSdk.New(platform)
		elseif platform == "guopanios" then
			require("sdk.GuopaniOSSdk")
			sdkUtils = GuopaniOSSdk.New(platform)
		elseif platform == "tbios" then
			require("sdk.TbiOSSdk")
			sdkUtils = TbiOSSdk.New(platform)
		elseif platform == "hmios" then
			require("sdk.HmiOSSdk")
			sdkUtils = HmiOSSdk.New(platform)
		elseif platform == "asios" then
			require("sdk.AsiOSSdk")
			sdkUtils = AsiOSSdk.New(platform)
		elseif platform == "game073ios" then
			require("sdk.ShuyouiOSSdk")
			sdkUtils = ShuyouiOSSdk.New(platform)
		elseif platform == "bdios" then
			require("sdk.BdiOSSdk")
			sdkUtils = BdiOSSdk.New(platform)
		elseif platform == "ppios" then
			require("sdk.PpiOSSdk")
			sdkUtils = PpiOSSdk.New(platform)
		else
			require("sdk.Localsdk")
			sdkUtils = Localsdk.New(platform)
		end
		sdkUtils.plat = "ios"
	end
	sdkUtils:initSdk()
end

function GameLogin.getJavaClassName()
	
end

function GameLogin.getOcClassName()
	-- body1
end

function GameLogin.OnNetworkChange(network_type)
	print("change network", network_type)
    GameNet._instance.network_type = network_type
end

function GameLogin.OnNetAsyncConnected(is_suc, handle, netid)
	GameNet._instance:OnAsyncConnected(is_suc, handle, netid)
end

function GameLogin.OnNetRecv(msg_type, net_id)
	if CheatDebugView.is_debug_print then
	    print("!!!!!!!!!!OnNetRecv!!!!!", msg_type, net_id)
	end
	GameNet._instance:OnRecvMsg(msg_type, net_id)
end

function GameLogin.OnNetDisconnect(net_id)
	GameNet._instance:OnDisconnect(net_id)
end