--[[
	@brief: Tips help view.
	@param：update/LevelUpdateView.lua
	@date：Created by Dongyang Cai on 8/7/2015
]]

LevelUpdateView = LevelUpdateView or BaseClass()

function LevelUpdateView:__init(root)
	self.screenSize = HandleRenderUnit:getWinSize()

	--Pop根节点
	self.base_node = cc.Control:create()
	self.base_node:setContentSize(self.screenSize)
	self.base_node:setAnchorPoint(cc.p(0.5, 0.5))
	self.base_node:setSwallowsTouches(true)
	self.base_node:setTouchEnabled(true)
	HandleRenderUnit:GetCoreScene():addToRenderGroup(self.base_node, cc.RenderQueue.GRQ_UI)
	self.base_node:getParent():reorderChild(self.base_node, 53)

	self.base_node:addTargetWithActionForControlEvent(close_func, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)

	--遮罩
	self.bg_cover = cc.LayerColor:create(cc.c4b(0, 0, 0, 255))
	self.bg_cover:setOpacity(127)
	self.base_node:addChild(self.bg_cover)

	self:configUI()
end

function LevelUpdateView:__delete()
	if self.base_node then
		self.base_node:removeFromParent()
		self.base_node = nil
	end
end

function LevelUpdateView:configUI()
	self.root_wnd = cc.Control:create()
	self.root_wnd:setPosition(self.screenSize.width/2, self.screenSize.height/2)
	self.root_wnd:setContentSize(cc.size(467, 253))
	self.base_node:addChild(self.root_wnd, 2)

	self.bg_0 = cc.SpriteUI:createWithResCSpriteLoader("assets/ui/p3updatepopup.csprite", "dikuang")
	self.bg_0:setPosition(233, 126)
	self.root_wnd:addChild(self.bg_0, 3)

	self.cancel_btn = cc.ControlButton:create(cc.Scale9SpriteUI:createWithResCSpriteLoader("assets/ui/p3updatepopup.csprite", "close"))
	self.cancel_btn:setPosition(125, 60)
	self.bg_0:addChild(self.cancel_btn, 0)
	
	self.confirm_btn = cc.ControlButton:create(cc.Scale9SpriteUI:createWithResCSpriteLoader("assets/ui/p3updatepopup.csprite", "download"))
	self.confirm_btn:setPosition(340, 60)
	self.bg_0:addChild(self.confirm_btn, 0)

	self.tmp1 = cc.Label:create()
	self.tmp1:setString("Tải update?")
	self.tmp1:setSystemFontSize(23)
	self.tmp1:setPosition(184, 190)
	self.tmp1:setColor(cc.c3b(255, 240, 170))
	self.bg_0:addChild(self.tmp1, 10)
	
	self.pack_size = cc.Label:create()
	self.pack_size:setString("10.99")
	self.pack_size:setSystemFontSize(23)
	self.pack_size:setPosition(328, 190)
	self.pack_size:setColor(cc.c3b(0, 255, 0))
	self.bg_0:addChild(self.pack_size, 10)
	
	self.tmp2 = cc.Label:create()
	self.tmp2:setString("M")
	self.tmp2:setSystemFontSize(23)
	self.tmp2:setPosition(381, 190)
	self.tmp2:setColor(cc.c3b(255, 240, 170))
	self.bg_0:addChild(self.tmp2, 10)
	
	self.tmp3 = cc.Label:create()
	self.tmp3:setString("(Kiến nghị dùng wifi để tải)")
	self.tmp3:setSystemFontSize(23)
	self.tmp3:setPosition(232, 160)
	self.tmp3:setColor(cc.c3b(255, 240, 170))
	self.bg_0:addChild(self.tmp3, 10)

	self.tmp4 = cc.Label:create()
	self.tmp4:setString("Có gói cấp mới để tải, click xác nhận để đóng game, đăng nhập lại game để tải gói cài")
	self.tmp4:setSystemFontSize(23)
	self.tmp4:setPosition(232, 130)
	self.tmp4:setColor(cc.c3b(255, 240, 170))
	self.bg_0:addChild(self.tmp4, 10)
end

--[[
	@brief: 绑定取消，确定func
	@param: cancel_func		取消点击响应
			confirm_func 	确定点击响应
]]
function LevelUpdateView:bindFunc(cancel_func, confirm_func)
	self.cancel_btn:addTargetWithActionForControlEvent(cancel_func, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
	self.confirm_btn:addTargetWithActionForControlEvent(confirm_func, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
end

--[[
	@brief: 设置等级包大小显示
	@param: size 	label 	
]]
function LevelUpdateView:setTitle(size)
	self.pack_size:setString(size)
end

--[[
	@brief: 显示关闭重登提示
]]
function LevelUpdateView:showCloseView()
	self.tmp1:removeFromParent()
	self.pack_size:removeFromParent()
	self.tmp2:removeFromParent()
	self.tmp3:removeFromParent()
	self.tmp4:removeFromParent()

	self.tmp5 = cc.Label:create()
	self.tmp5:setString("Chưa thêm mã lỗi vào quy ước")
	self.tmp5:setDimensions(400, 0)
	self.tmp5:setSystemFontSize(23)
	self.tmp5:setPosition(232, 160)
	self.tmp5:setColor(cc.c3b(255, 240, 170))
	self.bg_0:addChild(self.tmp5, 10)
end