--[[
    @brief: Game udpate view.
    @param：update/GameUpdate.lua
    @date：Created by Dongyang Cai on 4/11/2014
]]

SAlert = SAlert or BaseClass()

--[[
	@brief: 更新、登陆弹窗
	@param: content 		弹窗内容
			btn1_func 		按钮1回调
			btn1_txt 		按钮1显示Title
			btn2_func 		按钮2回调
			btn2_txt 		按钮2显示Titile
]]
function SAlert:__init(content, btn1_func, btn1_txt, btn2_func, btn2_txt)
	self.root_wnd = cc.Node:create()
	self.root_wnd:setPosition(-199, -94)
	HandleRenderUnit:GetCoreScene():addToRenderGroup(self.root_wnd, cc.RenderQueue.GRQ_UI2)
	self:_configUI(content, btn1_func, btn1_txt, btn2_func, btn2_txt)
end

function SAlert:__delete()
	if self.root_wnd then
		self.root_wnd:removeFromParent()
		self.root_wnd = nil
	end
end

function SAlert:_configUI(content, btn1_func, btn1_txt, btn2_func, btn2_txt)
	local function myOk()
		btn1_func()
		self:DeleteMe()
	end
	local function myNo()
		btn2_func()
		self:DeleteMe()
	end

	local bg = cc.Scale9SpriteUI:createWithResCSpriteLoader("assets/ui/p3common.csprite","bg")
	bg:setPosition(207, 134)
	bg:setContentSize(cc.size(414,267))
	self.root_wnd:addChild(bg)

	local btn_1 = cc.ControlButton:create(cc.Scale9SpriteUI:createWithResCSpriteLoader("assets/ui/p3common.csprite", "Btn_13_state1"))
	btn_1:setTitleForState(btn1_txt, cc.CONTROL_STATE_NORMAL)
	btn_1:setPosition(199, 60)
	btn_1:addTargetWithActionForControlEvent(myOk, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
	self.root_wnd:addChild(btn_1)

	local btn_2
	if btn2_func then
		btn_2 = cc.ControlButton:create(cc.Scale9SpriteUI:createWithResCSpriteLoader("assets/ui/p3common.csprite", "Btn_13_state1"))
		btn_2:setTitleForState(btn2_txt, cc.CONTROL_STATE_NORMAL)
		btn_1:setPosition(129, 60)
		btn_2:setPosition(285, 60)
		btn_2:addTargetWithActionForControlEvent(myNo, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
		self.root_wnd:addChild(btn_2)
	end

	self.label = cc.ControlRichLabel:create()
    self.label:setContentSize(cc.size(360,180))
    self.label:setPosition(30,50)
    self.label:setString(content)
    self.root_wnd:addChild(self.label)
end