--[[
	@brief: z controller.
	@param：update/UpdateController.lua
	@date：Created by Dongyang Cai on 3/11/2014
]]

require("update.config_update")
require("update.UpdateModel")
require("update.UpdateView")

UpdateController = UpdateController or BaseClass(BaseController)

function UpdateController:__init()
	self.event_list = {}
	self._model = UpdateModel:getInstance()

	self:registerAllProtocals()
	self:bindEvents()
end

function UpdateController:__delete()
	if self._update_view then
		self._update_view:DeleteMe()
	end
	self._update_view = nil
end

function UpdateController:registerAllProtocals()

end

function UpdateController:bindEvents()
	--显示登陆界面
	local function showUpdateView()
		if not self._update_view then
			self._update_view = UpdateView.New()
		end
		self._update_view:showView()
	end
	UpdateModel:getInstance():Bind(UpdateModel.SHOW_UPDATE_VIEW, showUpdateView)

	--显示index对应的View
	local function showView(index)
		if self._update_view then
			self._update_view:showView(index)
		end
	end
	UpdateModel:getInstance():Bind(UpdateModel.SHOW_VIEW, showView)
end